angular.module("myApp", ["ui.router"])
  .controller("MyReportsController", ["$rootScope", "$state", "$stateParams", function ($rootScope, $state, $stateParams) {
      var vm = this;
      vm.settings = $state.current.reportSettings;

      $rootScope.$on('$stateChangeStart', function (event, toState) {
          vm.settings = toState.reportSettings;

      });

  }]).config(["$urlRouterProvider", "$stateProvider", function ($urlRouterProvider, $stateProvider) {

      $urlRouterProvider.otherwise("/home");

      $stateProvider
        .state("home", {
            url: "/home",
            template: "<div> Click on a report above !  </div>",
        })

      .state("reports", {
          url: "/reports",
          templateUrl: "reports.template.html",
          controller: "MyReportsController",
          controllerAs: "report"
      })

      .state("reports.barcodes", {
          url: "/barcodes",
          reportSettings: {
              title: "Barcodes Report",
              reportName: "Reports/BarcodesReport.trdx",
              reportParams: {}
          },

      })

      .state("reports.sample", {
          url: "/sample",
          reportSettings: {
              title: "Sample Report",
              reportName: "Reports/SampleReport.trdx",
              reportParams: { 'Parameter1': 'test parameters' }
          }
      })

  }]).directive('report', function () {
      return {
          restrict: 'EA',
          transclude: 'true',
          scope: {
              name: '@',
              parameters: '@'
          },
          template: "HTML5 Viewer below:",
          link: function (scope, element, attrs) {
              //create the viewer object first, can be done in index.html as well
              var reportViewer = $("#reportViewer1").data("telerik_ReportViewer");
              if (!reportViewer) {

                  $("#reportViewer1").toggle();
                
                  $(document).ready(function () {
                      $("#reportViewer1").telerik_ReportViewer({
                          error: function (e, args) {
                              alert('Error from report directive:' + args);
                          },
                          reportSource: {
                              report: scope.name,
                              parameters: JSON.parse(scope.parameters),

                          },
                          serviceUrl: '/api/reports/',
                          scale: 1.0,
                          ready: function () {

                          },
                      })
                  });
              }
              //on state change update the report source
              scope.$watch('name', function () {

                  var reportViewer = $("#reportViewer1").data("telerik_ReportViewer");

                  if (reportViewer) {
                      var rs = reportViewer.reportSource();
                      if (rs && rs.report)
                          if (rs.report != scope.name &&
                              rs.parameters != scope.parameters) {
                         
                              reportViewer.reportSource({
                                  report: scope.name,
                                  parameters: JSON.parse(scope.parameters),
                              });
                          }
                  }
              });
          }
      }
  });